// 	Zaneme jako vdy standardnmi hlavikami a deklarac struktur pro nastaven terminl. 
// Promnnou peek_character pouvme pi testu stisknut klvesy. A dle zde uvdme
// prototypy funkc, s nimi budeme pozdji pracovat.
#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <term.h>
#include <curses.h>
#include <unistd.h>
static struct termios initial_settings, new_settings;
static int peek_character = -1;
void init_keyboard();
void close_keyboard();
int kbhit();
int readch();

// 	Funkce main vyvol funkci init_keyboard pro konfiguraci terminlu, a pot pejde do cyklu, 
// v jeho kad iteraci pok jednu sekundu a vyvol funkci kbhit. Pokud uivatel stiskl 
// klvesu q, obnov funkce close_keyboard normln chovn terminlu a chod programu se ukon.
int main()
{
    int ch = 0;

    init_keyboard();
    while(ch != 'q') {
        printf("cyklus\n");
        sleep(1);
        if(kbhit()) {
            ch = readch();
            printf("stiskl jste %c\n",ch);
        }
    }

    close_keyboard();
    exit(0);
}

// 	Dvojice funkc init_keyboard a close_keyboard slou ke konfiguraci 
// terminlu na zatku a konci programu:
void init_keyboard()
{
    tcgetattr(0,&initial_settings);
    new_settings = initial_settings;
    new_settings.c_lflag &= ~ICANON;
    new_settings.c_lflag &= ~ECHO;
    new_settings.c_lflag &= ~ISIG;
    new_settings.c_cc[VMIN] = 1;
    new_settings.c_cc[VTIME] = 0;
    tcsetattr(0, TCSANOW, &new_settings);
}

void close_keyboard()
{
    tcsetattr(0, TCSANOW, &initial_settings);
}

// 	A nyn konen pichz funkce, kter kontroluje stisk klvesy:
int kbhit()
{
    char ch;
    int nread;

    if(peek_character != -1)
        return 1;
    new_settings.c_cc[VMIN]=0;
    tcsetattr(0, TCSANOW, &new_settings);
    nread = read(0,&ch,1);
    new_settings.c_cc[VMIN]=1;
    tcsetattr(0, TCSANOW, &new_settings);

    if(nread == 1) {
        peek_character = ch;
        return 1;
    }
    return 0;
}

// 	Nsledujc funkce readch pete vlastn stisknut znak a pro dal prchod 
// cyklem obnov promnnou peek_character na -1.
int readch()
{
    char ch;

    if(peek_character != -1) {
        ch = peek_character;
        peek_character = -1;
        return ch;
    }
    read(0,&ch,1);
    return ch;
}

