// 	Pro zatek zalenme do programu jeden nov hlavikov soubor:
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <termios.h>

char *menu[] = {
    "a - pidat nov zznam",
    "d - odstranit zznam",
    "q - konec",
    NULL,
};

// 	Pot ve funkci main nadeklarujeme dv nov promnn:
int getchoice(char *greet, char *choices[], FILE *in, FILE *out);

int main()
{
    int choice = 0;
    FILE *input;
    FILE *output;
    struct termios initial_settings, new_settings;
// 	Charakteristiky terminlu musme zmnit jet ped vyvolnm funkce getchoice:
    if (!isatty(fileno(stdout))) {
    fprintf(stderr,"Program neb na terminlu, OK.\n");
    }

    input = fopen("/dev/tty", "r");
    output = fopen("/dev/tty", "w");
    if(!input || !output) {
        fprintf(stderr, "Nemohu otevt zazen /dev/tty\n");
        exit(1);
    }
    tcgetattr(fileno(input),&initial_settings);
    new_settings = initial_settings;
    new_settings.c_lflag &= ~ICANON;
    new_settings.c_lflag &= ~ECHO;
    new_settings.c_cc[VMIN] = 1;
    new_settings.c_cc[VTIME] = 0;
    new_settings.c_lflag &= ~ISIG;
    if(tcsetattr(fileno(input), TCSANOW, &new_settings) != 0) {
        fprintf(stderr,"nemohu nastavit atributy\n");
    }

// 	A opt ped ukonenm programu vrtme nastaven terminlu do pvodnho stavu:
    do {
        choice = getchoice("Vyberte prosm operaci", menu, input, output);
        printf("Zvolili jste: %c\n", choice);
    } while (choice != 'q');
    tcsetattr(fileno(input),TCSANOW,&initial_settings);
    exit(0);
}

// 	Protoe se nachzme v nekanonickm reimu, neprovd se vchoz mapovn 
// znak CR na LF, take musme nvraty vozku kontrolovat sami.
int getchoice(char *greet, char *choices[], FILE *in, FILE *out)
{
    int chosen = 0;
    int selected;
    char **option;

    do {
        fprintf(out, "Volba: %s\n",greet);
        option = choices;
        while(*option) {
            fprintf(out, "%s\n",*option);
            option++;
        }
        do {
            selected = fgetc(in);
        } while (selected == '\n' || selected == '\r');
        option = choices;
        while(*option) {
            if(selected == *option[0]) {
                chosen = 1;
                break;
            }
            option++;
        }
        if(!chosen) {
            fprintf(out, "Nesprvn volba, vyberte znovu\n");
        }
    } while(!chosen);
    return selected;
}

