#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <ndbm.h>

/* Na nkterch systmech je nutn deklaraci zamnit za 
#include <gdbm-ndbm.h>
*/

#include <string.h>

#define TEST_DB_FILE "/tmp/dbm2_test"
#define ITEMS_USED 3

struct test_data {
    char misc_chars[15];
    int any_integer;
    char more_chars[21];
};

int main()
{
// 	Ve funkci main vytvome struktury items_to_store a item_retrieved, etzec key a struktury typu datum:
    struct test_data items_to_store[ITEMS_USED];
    struct test_data item_retrieved;

    char key_to_use[20];
    int i, result;

    datum key_datum;
    datum data_datum;

    DBM *dbm_ptr;
// 	Po deklaraci ukazatele na strukturu typu dbm meme otevt pokusnou 
// databzi pro ten i pro zpis; neexistuje-li, vytvome ji:
    dbm_ptr = dbm_open(TEST_DB_FILE, O_RDWR | O_CREAT, 0666);
    if (!dbm_ptr) {
        fprintf(stderr, "Oteven databze selhalo\n");
        exit(EXIT_FAILURE);
    }
// Nyn do pole struktur items_to_store zapeme njak data:
    memset(items_to_store, '\0', sizeof(items_to_store));
    strcpy(items_to_store[0].misc_chars, "Prvn!");
    items_to_store[0].any_integer = 47;
    strcpy(items_to_store[0].more_chars, "foo");

    strcpy(items_to_store[1].misc_chars, "bar");
    items_to_store[1].any_integer = 13;
    strcpy(items_to_store[1].more_chars, "netst?");

    strcpy(items_to_store[2].misc_chars, "Tet");
    items_to_store[2].any_integer = 3;
    strcpy(items_to_store[2].more_chars, "baz");
// Ke kad poloce musme vytvoit kl, pes kter se na ni budeme odkazovat.
// Konkrtn to bude prvn psmeno kadho etzce a cel slo. Kl pak identifikuje 
// struktura key_datum, zatmco data_datum se odvolv na vlastn poloku 
// z pole items_to_store. Nakonec data ulome do databze:
    for (i = 0; i < ITEMS_USED; i++) {
        sprintf(key_to_use, "%c%c%d",
                items_to_store[i].misc_chars[0],
                items_to_store[i].more_chars[0],
                items_to_store[i].any_integer);

        key_datum.dptr = (void *)key_to_use;
        key_datum.dsize = strlen(key_to_use);
        data_datum.dptr = (void *)&items_to_store[i];
        data_datum.dsize = sizeof(struct test_data);

        result = dbm_store(dbm_ptr, key_datum, data_datum, DBM_REPLACE);
        if (result != 0) {
            fprintf(stderr, "dbm_store selhalo s klem %s\n", key_to_use);
            exit(2);
        }
    }
/* te zkusme njak data odstranit */
    sprintf(key_to_use, "bn%d", 13);
    key_datum.dptr = key_to_use;
    key_datum.dsize = strlen(key_to_use);

    if (dbm_delete(dbm_ptr, key_datum) == 0) {
        printf("Data s klem %s odstranna\n", key_to_use);
    }
    else {
        printf("Pro kl %s nebylo nic odstranno\n", key_to_use);
    }

    for (key_datum = dbm_firstkey(dbm_ptr);
                key_datum.dptr;
                key_datum = dbm_nextkey(dbm_ptr)) {
        data_datum = dbm_fetch(dbm_ptr, key_datum);
        if (data_datum.dptr) {
            printf("Data natena\n");
            memcpy(&item_retrieved, data_datum.dptr, data_datum.dsize);
            printf("Naten poloka - %s %d %s\n",
                    item_retrieved.misc_chars,
                    item_retrieved.any_integer,
                    item_retrieved.more_chars);
        }
        else {
            printf("Data nenalezena pro kl %s\n", key_to_use);
        }
    }

    dbm_close(dbm_ptr);
    exit(EXIT_SUCCESS);
}

