#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>

const char *test_file = "/tmp/test_lock";

int main()
{
    int file_desc;
    int byte_count;
    char *byte_to_write = "A";
    struct flock region_1;
    struct flock region_2;
    int res;
// Nyn oteveme souborov deskriptor:
    file_desc = open(test_file, O_RDWR | O_CREAT, 0666);
    if (!file_desc) {
        fprintf(stderr, "Nemohu otevt %s pro ten/zpis\n", test_file);
        exit(EXIT_FAILURE);
    }
// Do souboru zapeme njak data:
    for(byte_count = 0; byte_count < 100; byte_count++) {
        (void)write(file_desc, byte_to_write, 1);
    }
// V bajtech 10 a 30 vytvome oblast 1 se sdlenm zmkem:
    region_1.l_type = F_RDLCK;
    region_1.l_whence = SEEK_SET;
    region_1.l_start = 10;
    region_1.l_len = 20;
// Druh oblast v bajtech 40 a 50 bude mt vhradn zmek:
    region_2.l_type = F_WRLCK;
    region_2.l_whence = SEEK_SET;
    region_2.l_start = 40;
    region_2.l_len = 10;
// Nyn soubor uzamkneme:
    printf("Proces %d uzamyk soubor\n", getpid());
    res = fcntl(file_desc, F_SETLK, &region_1);
    if (res == -1) fprintf(stderr, "Nepodailo se uzamknout oblast 1\n");
    res = fcntl(file_desc, F_SETLK, &region_2);
    if (res == -1) fprintf(stderr, "Nepodailo se uzamknout oblast 2\n");
// A chvli pokme:
    sleep(60);

    printf("Proces %d uzavr soubor\n", getpid());
    close(file_desc);
    exit(EXIT_SUCCESS);
}

