#include <stdlib.h>
#include <stdio.h>

#include "mysql.h"

MYSQL my_connection;
MYSQL_RES *res_ptr;
MYSQL_ROW sqlrow;

void display_header();
void display_row();

int main(int argc, char *argv[]) {
    int res;
    int first_row = 1; /* Tato promnn zajist, e zhlav dk
                    vypeme pi spnm naten dat jen jednou */

    mysql_init(&my_connection);
    if (mysql_real_connect(&my_connection, "localhost", "rick",
                           "tajn", "foo", 0, NULL, 0)) {
        printf("Pipojen je spn\n");

        res = mysql_query(&my_connection, "SELECT childno, fname, age FROM children WHERE age > 5");
        if (res) {
                fprintf(stderr, "Chyba pi SELECT: %s\n", mysql_error(&my_connection));
        } else {
            res_ptr = mysql_use_result(&my_connection);
            if (res_ptr) {
                while ((sqlrow = mysql_fetch_row(res_ptr))) {
                    if (first_row) {
                        display_header();
                        first_row = 0;
                    }
                    display_row();
                }
                if (mysql_errno(&my_connection)) {
                    fprintf(stderr, "Chyba pi natn: %s\n",
                            mysql_error(&my_connection));
                }
                mysql_free_result(res_ptr);
            }
        }
        mysql_close(&my_connection);
    } else {
        fprintf(stderr, "Pipojen selhalo\n");
        if (mysql_errno(&my_connection)) {
            fprintf(stderr, "Chyba pipojen %d: %s\n",
                        mysql_errno(&my_connection),
                        mysql_error(&my_connection));
        }
    }
    return EXIT_SUCCESS;
}

void display_header() {
    MYSQL_FIELD *field_ptr;

    printf("daje o sloupcch:\n");
    while ((field_ptr = mysql_fetch_field(res_ptr)) != NULL) {
        printf("\t Nzev: %s\n", field_ptr->name);
        printf("\t Typ: ");
        if (IS_NUM(field_ptr->type)) {
            printf("seln pole\n");
        } else {
            switch(field_ptr->type) {
                case FIELD_TYPE_VAR_STRING:
                    printf("VARCHAR\n");
                    break;
                case FIELD_TYPE_LONG:
                    printf("LONG\n");
                    break;
                default:
                    printf("Typ je %d, zkontrolujte v mysql_com.h\n", field_ptr->type);
            } /* switch */
        } /* else */

        printf("\t Max. ka %ld\n", field_ptr->length);
        if (field_ptr->flags & AUTO_INCREMENT_FLAG)
            printf("\t Automatick inkrementace\n");
        printf("\n");
    } /* while */
}

void display_row() {
    unsigned int field_count;

    field_count = 0;
    while (field_count < mysql_field_count(&my_connection)) {
        if (sqlrow[field_count]) printf("%s ", sqlrow[field_count]);
        else printf("NULL");
        field_count++;
    }
    printf("\n");
}

