/*
	Prvn program shm1.c je konzument. Po obvyklm zalenn hlavikovch soubor 
	pejdeme k voln shmget, do nho zadme pznak IPC_CREAT a vytvome tm 
	segment sdlen pamti, jeho velikost je rovn velikosti datov struktury:
*/
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <sys/shm.h>
#include "shm_com.h"

int main()
{
    int running = 1;
    void *shared_memory = (void *)0;
    struct shared_use_st *shared_stuff;
    int shmid;

    srand((unsigned int)getpid());

    shmid = shmget((key_t)1234, sizeof(struct shared_use_st), 0666 | IPC_CREAT);

    if (shmid == -1) {
        fprintf(stderr, "shmget selhalo\n");
        exit(EXIT_FAILURE);
    }
/* Nyn sdlenou pam zpstupnme v programu: */
    shared_memory = shmat(shmid, (void *)0, 0);
    if (shared_memory == (void *)-1) {
        fprintf(stderr, "shmat selhalo\n");
        exit(EXIT_FAILURE);
    }

    printf("Pam pipojena na adrese %X\n", (int)shared_memory);
/*
	Dal st programu piad segment shared_memory do struktury shared_stuff, 
	z n pak vypisujeme ppadn text. Cyklus pokrauje tak dlouho, dokud se v 
	textu neobjev etzec end. Voln sleep v konzumentovi 
	mysln prodlou kritickou sekci a producent tud mus ekat:
*/
    shared_stuff = (struct shared_use_st *)shared_memory;
    shared_stuff->written_by_you = 0;

    while(running) {
        if (shared_stuff->written_by_you) {
            printf("Napsal jsi: %s", shared_stuff->some_text);
            sleep( rand() % 4 ); /* a na ns druh proces hezky pok! */
            shared_stuff->written_by_you = 0;
            if (strncmp(shared_stuff->some_text, "end", 3) == 0) {
                running = 0;
            }
        }
    }
// Nakonec sdlenou pam odpojme a odstranme:
    if (shmdt(shared_memory) == -1) {
        fprintf(stderr, "shmdt selhalo\n");
        exit(EXIT_FAILURE);
    }

    if (shmctl(shmid, IPC_RMID, 0) == -1) {
        fprintf(stderr, "shmctl(IPC_RMID) selhalo\n");
        exit(EXIT_FAILURE);
    }

    exit(EXIT_SUCCESS);
}
