/* Na zatek obvykl direktivy #include a deklarace promnnch */

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
    char *host;
    int sockfd;
    int len, result;
    struct sockaddr_in address;
    struct hostent *hostinfo;
    struct servent *servinfo;
    char buffer[128];

    if(argc == 1)
        host = "localhost";
    else
        host = argv[1];

    /* Zjistme adresu hostitele a pokud ji nenajdeme, oznmme chybu */

    hostinfo = gethostbyname(host);
    if(!hostinfo) {
        fprintf(stderr, "hostitel neexistuje: %s\n", host);
        exit(1);
    }

    /* Zkontrolujeme, jestli je sluba daytime k dispozici */

    servinfo = getservbyname("daytime", "udp");
    if(!servinfo) {
        fprintf(stderr,"sluba daytime nen k dispozici\n");
        exit(1);
    }

    printf("port sluby daytime je %d\n", ntohs(servinfo -> s_port));

    /* Vytvoen soketu UDP */

    sockfd = socket(AF_INET, SOCK_DGRAM, 0);

    /* Zkonstruujeme adresu pro voln sendto/recvfrom... */

    address.sin_family = AF_INET;
    address.sin_port = servinfo -> s_port;
    address.sin_addr = *(struct in_addr *)*hostinfo -> h_addr_list;
    len = sizeof(address);

    result = sendto(sockfd, buffer, 1, 0, (struct sockaddr *)&address, len);
    result = recvfrom(sockfd, buffer, sizeof(buffer), 0,
                     (struct sockaddr *)&address, &len);
    buffer[result] = '\0';
    printf("peteno %d bajt: %s", result, buffer);

    close(sockfd);
    exit(0);
}

