#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "mysql.h"
#include "app_mysql.h"

static MYSQL my_connection;
static int dbconnected = 0;

static int get_artist_id(char *artist);

/*
	Navzat pipojen k databzi je velice jednoduch, jak jsme si 
	u v kapitole ukzali, a odpojen od databze je jet jednodu:
*/

int database_start(char *name, char *pwd) {
    if (dbconnected) return 1;

    mysql_init(&my_connection);
    if (!mysql_real_connect(&my_connection, "localhost", name, pwd, 
            "blpcd", 0, NULL, 0)) {
        fprintf(stderr, "Pipojen k databzi selhalo: %d, %s\n",
        mysql_errno(&my_connection), mysql_error(&my_connection));
        return 0;
    }
    dbconnected = 1;
    return 1;
} /* database start */

void database_end() {
    if (dbconnected) mysql_close(&my_connection);
    dbconnected = 0;
} /* database_end */

/*
	Te zane skuten prce, a to ve funkci add_cd. Nejprve pichz 
	nkolik deklarac a nkolik kontrol, pi nich si ovme, jestli 
	jsme sprvn pipojeni k databzi. Tato kontrola nechyb v 
	dn na zvenku dostupn funkci.
*/
int add_cd(char *artist, char *title, char *catalogue, int *cd_id) {
    MYSQL_RES *res_ptr;
    MYSQL_ROW mysqlrow;
    int res;
    char is[250];
    char es[250];
    int artist_id = -1;
    int new_cd_id = -1;
    if (!dbconnected) return 0;

    artist_id = get_artist_id(artist);

    mysql_escape_string(es, title, strlen(title));
    sprintf(is, "INSERT INTO cd(title, artist_id, catalogue) VALUES('%s', %d, '%s')", es, artist_id, catalogue);
    res = mysql_query(&my_connection, is);
    if (res) {
        fprintf(stderr, "Chyba pi vloen %d: %s\n",
        mysql_errno(&my_connection), mysql_error(&my_connection));
        return 0;
    }

    res = mysql_query(&my_connection, "SELECT LAST_INSERT_ID()");

    if (res) {
        printf("Chyba pi SELECT: %s\n", mysql_error(&my_connection));
        return 0;
    } else {
        res_ptr = mysql_use_result(&my_connection);

        if (res_ptr) {
            if ((mysqlrow = mysql_fetch_row(res_ptr))) {
                sscanf(mysqlrow[0], "%d", &new_cd_id);
            }
            mysql_free_result(res_ptr);
        }

        *cd_id = new_cd_id;
        if (new_cd_id != -1) return 1;

        return 0;
    }
} /* add_cd */

// Nyn se podvme na implementaci funkce get_artist_id; postup je velice podobn vkldn zznamu s CD:
/* Najde nebo vytvo artist_id pro zadan etzec */
static int get_artist_id(char *artist) {
    MYSQL_RES *res_ptr;
    MYSQL_ROW mysqlrow;

    int res;
    char qs[250];
    char is[250];
    char es[250];
    int artist_id = -1;

    /* Existuje ji umlec? */
    mysql_escape_string(es, artist, strlen(artist));
    sprintf(qs, "SELECT id FROM artist WHERE name = '%s'", es);

    res = mysql_query(&my_connection, qs);
    if (res) {
        fprintf(stderr, "Chyba SELECT: %s\n", mysql_error(&my_connection));
    } else {
        res_ptr = mysql_store_result(&my_connection);
        if (res_ptr) {
            if (mysql_num_rows(res_ptr) > 0) {
                if (mysqlrow = mysql_fetch_row(res_ptr)) {
                    sscanf(mysqlrow[0], "%d", &artist_id);
                }
            }
            mysql_free_result(res_ptr);
        }
    }
    if (artist_id != -1) return artist_id;

    sprintf(is, "INSERT INTO artist(name) VALUES('%s')", es);
    res = mysql_query(&my_connection, is);
    if (res) {
        fprintf(stderr, "Chyba pi vloen %d: %s\n",
        mysql_errno(&my_connection), mysql_error(&my_connection));
        return 0;
    }

    res = mysql_query(&my_connection, "SELECT LAST_INSERT_ID()");
    if (res) {
        printf("Chyba pi SELECT: %s\n", mysql_error(&my_connection));
        return 0;
    } else {
        res_ptr = mysql_use_result(&my_connection);
        if (res_ptr) {
            if ((mysqlrow = mysql_fetch_row(res_ptr))) {
                sscanf(mysqlrow[0], "%d", &artist_id);
            }
            mysql_free_result(res_ptr);
        }
    }
    return artist_id;
} /* get_artist_id */

// Nyn si ukeme pidn informac o stopch na novm CD. 
// Opt musme zachovat ppadn speciln znaky v titulu:
int add_tracks(struct current_tracks_st *tracks) {
    int res;
    char is[250];
    char es[250];
    int i;

    if (!dbconnected) return 0;

    i = 0;
    while (tracks->track[i][0]) {
        mysql_escape_string(es, tracks->track[i], strlen(tracks->track[i]));
        sprintf(is, "INSERT INTO track(cd_id, track_id, title) VALUES(%d, %d, '%s')", tracks->cd_id, i + 1, es);
        res = mysql_query(&my_connection, is);
        if (res) {
            fprintf(stderr, "Chyba pi vloen %d: %s\n",
            mysql_errno(&my_connection), mysql_error(&my_connection));
            return 0;
        }
        i++;
    }
    return 1;
} /* add_tracks */

/*
	V dal sti pechzme k natn informac o CD podle zadan hodnoty ID. 
	Zde budeme potebovat databzov spojen tabulek (join), kdy spolen s 
	informacemi o CD nateme tak daje o umlci. Tento postup je velice 
	rozumn, protoe databze um efektivn provdt i sloit dotazy. 
	Nepokouejte se proto v kdu aplikace dlat vci, kter se daj jednodue 
	zapsat v jazyce SQL; tm si nejen uette zbytenou prci, ale zrove 
	urychlte innost aplikace, kter podstatnou st prce "sv" databzovmu stroji.
*/
int get_cd(int cd_id, struct current_cd_st *dest) {
    MYSQL_RES *res_ptr;
    MYSQL_ROW mysqlrow;

    int res;
    char qs[250];

    if (!dbconnected) return 0;
    memset(dest, 0, sizeof(*dest));
    dest->artist_id = -1;

    sprintf(qs, "SELECT artist.id, cd.id, artist.name, cd.title, cd.catalogue \
    FROM artist, cd WHERE artist.id = cd.artist_id and cd.id = %d", cd_id);

    res = mysql_query(&my_connection, qs);
    if (res) {
        fprintf(stderr, "Chyba pi SELECT: %s\n", mysql_error(&my_connection));
    } else {
        res_ptr = mysql_store_result(&my_connection);
        if (res_ptr) {
            if (mysql_num_rows(res_ptr) > 0) {
                if (mysqlrow = mysql_fetch_row(res_ptr)) {
                    sscanf(mysqlrow[0], "%d", &dest->artist_id);
                    sscanf(mysqlrow[1], "%d", &dest->cd_id);
                    strcpy(dest->artist_name, mysqlrow[2]);
                    strcpy(dest->title, mysqlrow[3]);
                    strcpy(dest->catalogue, mysqlrow[4]);
                }
            }
            mysql_free_result(res_ptr);
        }
    }
    if (dest->artist_id != -1) return 1;
    return 0;
} /* get_cd */

/*
	Dle pichz na adu implementace funkce pro natn informac o stopch. 
	Vimnte si, e jsme do pkazu SQL zapsali klausuli ORDER BY, kter vrac 
	stopy v "rozumnm" poad. Tuto operaci opt ponechme na databzi, k
	ter ji zvldne mnohem efektivnji ne my sami v programovm kdu:
*/
int get_cd_tracks(int cd_id, struct current_tracks_st *dest) {
    MYSQL_RES *res_ptr;
    MYSQL_ROW mysqlrow;

    int res;
    char qs[250];
    int i = 0, num_tracks = 0;

    if (!dbconnected) return 0;
    memset(dest, 0, sizeof(*dest));
    dest->cd_id = -1;

    sprintf(qs, "SELECT track_id, title FROM track WHERE track.cd_id = %d \
            ORDER BY track_id", cd_id);

    res = mysql_query(&my_connection, qs);
    if (res) {
        fprintf(stderr, "Chyba pi SELECT: %s\n", mysql_error(&my_connection));
    } else {
        res_ptr = mysql_store_result(&my_connection);
        if (res_ptr) {
            if ((num_tracks = mysql_num_rows(res_ptr)) > 0) {
                while (mysqlrow = mysql_fetch_row(res_ptr)) {
                    strcpy(dest->track[i], mysqlrow[1]);
                    i++;
                }
                dest->cd_id = cd_id;
            }
            mysql_free_result(res_ptr);
        }
    }
    return num_tracks;
} /* get_cd_tracks */

/*
	Zatm jsme zvldli funkce pro vkldn a natn informac o CD a nyn 
	je na ase podvat se na vyhledvn. Pro jednoduchost rozhran jsme 
	omezili poet navrcench vsledk, zrove ale chceme zjistit, kolik 
	dk bylo nalezeno (pestoe je jich vce, ne kolik najednou nateme).
*/
int find_cds(char *search_str, struct cd_search_st *dest) {
    MYSQL_RES *res_ptr;
    MYSQL_ROW mysqlrow;

    int res;
    char qs[500];
    int i = 0;
    char ss[250];
    int num_rows = 0;

    if (!dbconnected) return 0;
// Vymaeme strukturu vsledk a opt nezapomeneme na zachovn specilnch znak v dotazu:
    memset(dest, -1, sizeof(*dest));
    mysql_escape_string(ss, search_str, strlen(search_str));
/*
	Dle musme sestavit etzec s dotazem. Vimnte si velkho mnostv znak %; 
	to je proto, e znak procenta potebujeme jednak zapsat do dotazu SQL (kde 
	se shoduje s libovolnm etzcem) a jednak je specilnm znakem ve funkci sprintf.
*/
    sprintf(qs, "SELECT DISTINCT artist.id, cd.id FROM artist, cd WHERE artist.id =\
            cd.artist_id and (artist.name LIKE '%%%s%%' OR cd.title LIKE '%%%s%%' OR\
            cd.catalogue LIKE '%%%s%%')", ss, ss, ss);
// Hotov dotaz meme spustit:
    res = mysql_query(&my_connection, qs);

    if (res) {
        fprintf(stderr, "Chyba pi SELECT: %s\n", mysql_error(&my_connection));
    } else {
        res_ptr = mysql_store_result(&my_connection);
        if (res_ptr) {
            num_rows = mysql_num_rows(res_ptr);
            if ( num_rows > 0) {
                while ((mysqlrow = mysql_fetch_row(res_ptr)) && i < MAX_CD_RESULT) {
                    sscanf(mysqlrow[1], "%d", &dest->cd_id[i]);
                    i++;
                }
            }
            mysql_free_result(res_ptr);
        }
    }
    return num_rows;
} /* find_cds */

/* 
	A nakonec se pustme do implementace odstraovn CD. V souladu s politikou 
	"tich" obsluhy poloek umlc musme odstranit umlce danho CD, pokud u 
	nem v databzi dn jin CD. Jazyk SQL kupodivu neum vyjdit odstrann
	dat z nkolika tabulek, take musme z kad tabulky odstranit dky zvlṻ.
*/
int delete_cd(int cd_id) {
    int res;
    char qs[250];
    int artist_id, num_rows;
    MYSQL_RES *res_ptr;
    MYSQL_ROW mysqlrow;

    if (!dbconnected) return 0;

    artist_id = -1;
    sprintf(qs, "SELECT artist_id FROM cd WHERE artist_id = (SELECT artist_id FROM cd WHERE id = '%d')", cd_id);
    res = mysql_query(&my_connection, qs);

    if (res) {
        fprintf(stderr, "Chyba pi SELECT: %s\n", mysql_error(&my_connection));
    } else {
        res_ptr = mysql_store_result(&my_connection);
        if (res_ptr) {
            num_rows = mysql_num_rows(res_ptr);
            if (num_rows == 1) {
                /* Umlec se nevyskytuje na dnm jinm CD */
                mysqlrow = mysql_fetch_row(res_ptr);
                sscanf(mysqlrow[0], "%d", &artist_id);
            }
        mysql_free_result(res_ptr);
        }
    }

    sprintf(qs, "DELETE FROM track WHERE cd_id = '%d'", cd_id);
    res = mysql_query(&my_connection, qs);
    if (res) {
        fprintf(stderr, "Chyba pi odstrann stopy %d: %s\n",
        mysql_errno(&my_connection), mysql_error(&my_connection));
        return 0;
    }

    sprintf(qs, "DELETE FROM cd WHERE id = '%d'", cd_id);
    res = mysql_query(&my_connection, qs);
    if (res) {
        fprintf(stderr, "Chyba pi odstrann CD %d: %s\n",
        mysql_errno(&my_connection), mysql_error(&my_connection));
        return 0;
    }

    if (artist_id != -1) {
        /* k poloce tohoto umlce neexistuje dn jin CD, smaeme jej */
        sprintf(qs, "DELETE FROM artist WHERE id = '%d'", artist_id);
        res = mysql_query(&my_connection, qs);
        if (res) {
            fprintf(stderr, "Chyba pi odstrann umlce %d: %s\n",
            mysql_errno(&my_connection), mysql_error(&my_connection));
        }
    }
    return 1;
} /* delete_cd */

