/*
	Nejprve zalenme hlavikov soubor a nadeklarujeme extern globln 
	promnn, definovan v souboru interface.c, jejich prostednictvm 
	budeme st a aktualizovat vlastnosti ovldacch prvk:
*/
#include "app_gnome.h"

extern GtkWidget *treeview;
extern GtkWidget *app;
extern GtkWidget *appbar;
extern GtkWidget *artist_entry;
extern GtkWidget *title_entry;
extern GtkWidget *catalogue_entry;

static GtkWidget *addcd_dialog;
// Ve funkci quit_app volme ped ukonenm programu rutinu database_end, 
// kter provede klid a uzaven databze:
void quit_app( GtkWidget *window, gpointer data)
{
    database_end();
    gtk_main_quit();
}
// Dal funkce vype jednoduch dialog s potvrzenm ukonen aplikace; 
// odpov vrac jako hodnotu typu gboolean:
gboolean confirm_exit()
{
    gint result;
    GtkWidget *dialog = gtk_message_dialog_new (NULL,
                            GTK_DIALOG_MODAL,
                            GTK_MESSAGE_QUESTION,
                            GTK_BUTTONS_YES_NO,
                            "Chcete urit aplikaci ukonit?");

    result = gtk_dialog_run (GTK_DIALOG (dialog));
    gtk_widget_destroy (dialog);

    return (result == GTK_RESPONSE_YES);
}
/*
	Rutina delete_event_handler je funkc zptnho voln, napojen na udlost 
	GDK delete_event hlavnho okna. Tato udlost je vygenerovna vdy pi pokusu 
	o uzaven okna, ale jet ped odeslnm signlu GTK+ pro odstrann okna:
*/
gboolean delete_event_handler ( GtkWidget *window, GdkEvent *event, gpointer data)
{
    return !confirm_exit();
}
/*
	Nsledujc funkce je vyvolna v okamiku klepnut na tlatko v dialogu 
	pro pidn CD. Pokud uivatel klepnul na tlatko Budi, zkopruje program 
	zadan etzce do nekonstantnho znakovho pole a ped je do funkce add_cd v 
	rozhran databze MySQL:
*/
void addcd_dialog_button_clicked (GtkDialog * dialog, 
                  gint response, gpointer userdata)
{
    const gchar *artist_const;
    const gchar *title_const;
    const gchar *catalogue_const;
    gchar artist[200];
    gchar title[200];
    gchar catalogue[200];
    gint cd_id;

    if (response == GTK_RESPONSE_ACCEPT)
    {
        artist_const = gtk_entry_get_text(GTK_ENTRY (artist_entry));
        title_const = gtk_entry_get_text(GTK_ENTRY (title_entry));
        catalogue_const = gtk_entry_get_text(GTK_ENTRY (catalogue_entry));

        strcpy(artist, artist_const);
        strcpy(title, title_const);
        strcpy(catalogue, catalogue_const);

        add_cd(artist, title, catalogue, &cd_id);
    }

    addcd_dialog = NULL;
    gtk_widget_destroy(GTK_WIDGET(dialog));
}
// Tato funkce je jdrem cel aplikace: nat vsledky hledn 
// a napluje podle nich ovldac prvek GtkTreeView:
void on_search_button_clicked (GtkButton *button, gpointer userdata)
{
    struct cd_search_st cd_res;
    struct current_cd_st cd;
    struct current_tracks_st ct;
    gint res1, res2, res3;
    gchar track_title[110];
    const gchar *search_string_const;
    gchar search_string[200];
    gchar search_text[200];
    gint i = 0, j = 0;

    GtkTreeStore *tree_store;
    GtkTreeIter parent_iter, child_iter;

    memset(&track_title, 0, sizeof(track_title));
// Zde nateme vyhledvac etzec ze vstupnho textovho pole, zkoprujeme 
// jej do nekonstantn promnn a nateme odpovdajc identifiktory CD:
    search_string_const = gtk_entry_get_text(GTK_ENTRY (userdata));
    strcpy (search_string, search_string_const);
    res1 = find_cds(search_string, &cd_res);
// Nyn aktualizujeme panel appbar a zobrazme v nm uivateli 
// informace o vsledcch hledn:
    sprintf(search_text, " Zobrazuji %d vsledk hledn etzce ' %s '",
            MIN(res1, MAX_CD_RESULT), search_string);
    gnome_appbar_push (GNOME_APPBAR( appbar), search_text);
/*
	Mme-li "v ruce" vsledky hledn, meme jimi konen naplnit ovldac 
	prvek GtkTreeView. Ke kadmu identifiktoru CD musme nast odpovdajc 
	strukturu current_cd_st struct, kter obsahuje titul a autora CD, a pot 
	jet seznam jeho stop. Abychom objekt GtkTreeView nepeplovali, je poet 
	poloek omezen konstantou MAX_CD_RESULT, definovanou v souboru app_mysql.h.
*/
    tree_store = gtk_tree_store_new (N_COLUMNS,
                                     G_TYPE_STRING,
                                     G_TYPE_STRING,
                                     G_TYPE_STRING);

    while (i < res1 && i < MAX_CD_RESULT)
    {
        res2 = get_cd(cd_res.cd_id[i], &cd);

        /* Pidn novho dku do modelu */
        gtk_tree_store_append (tree_store, &parent_iter, NULL);
        gtk_tree_store_set (tree_store, &parent_iter,
                            COLUMN_TITLE, cd.title,
                            COLUMN_ARTIST, cd.artist_name,
                            COLUMN_CATALOGUE, cd.catalogue, -1
                            );

        res3 = get_cd_tracks(cd_res.cd_id[i++], &ct);
        j = 0;

        /* Naplnn stromu stopami aktulnho CD */
        while (j < res3)
        {
            sprintf(track_title, " Stopa %d. ", j+1);
            strcat(track_title, ct.track[j++]);

            gtk_tree_store_append (tree_store, &child_iter, &parent_iter);
            gtk_tree_store_set (tree_store, &child_iter,
                                COLUMN_TITLE, track_title, -1);
        }
    }

    gtk_tree_view_set_model (GTK_TREE_VIEW (treeview), GTK_TREE_MODEL(tree_store));
}
// Dialog addcd je nemodln. Ped jeho vlastnm vytvoenm a zobrazenm 
// musme proto zkontrolovat, jestli u nen aktivn v jin instanci:
void on_addcd_activate (GtkMenuItem * menuitem, gpointer user_data)
{
    if (addcd_dialog != NULL)
        return;

    addcd_dialog = create_addcd_dialog();
    gtk_widget_show_all (addcd_dialog);
}

gboolean close_app ( GtkWidget * window, gpointer data)
{
    gboolean exit;

    if ((exit = confirm_exit()))
    {
        quit_app(NULL, NULL);
    }
    return exit;
}

// Po klepnut na tlatko "O aplikaci" se zobraz standardn dialog GNOME about:
void on_about_activate (GtkMenuItem * menuitem, gpointer user_data)
{
    const char * authors[] = {"Wrox Press", NULL};

    GtkWidget *about = gnome_about_new ("Databze CD", "1.0",
                                        "(c) Wrox Press",
                                        "Linux - zanme programovat",
                                        (const char ** ) authors, NULL,
                                        "Peklad", NULL);

    gtk_widget_show(about);
}

// ukonen aplikace
void on_quit_activate (GtkMenuItem  * menuitem, gpointer user_data)
{
  close_app(NULL, NULL);
}

